#ifndef __MODE3_H__
#define __MODE3_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define MODE3_MAX_SCREEN_SIZE		(SCREEN_CX * SCREEN_CY * 2)
#define MODE3_MAX_BUF_SIZE			(SCREEN_CX * SCREEN_CY * 2 * 2)
#define MODE3_MAX_MASK_SIZE			(SCREEN_CX * SCREEN_CY)
#define MODE3_MAX_FACE_SIZE			(64 * 64 * 2)


//---------------------------------------------------------------------------
typedef struct {
	bool isDrawBuf;
	bool isDrawFace;

	u16  buf[MODE3_MAX_BUF_SIZE/2]   ALIGN(4);
	u8   mask[MODE3_MAX_MASK_SIZE]   ALIGN(4);
	u16  face[MODE3_MAX_FACE_SIZE/2] ALIGN(4);

} ST_MODE3;


//---------------------------------------------------------------------------
EWRAM_CODE void Mode3Init(void);

IWRAM_CODE void Mode3Exec(void);
IWRAM_CODE void Mode3ExecBuf(void);
IWRAM_CODE void Mode3ExecFace(void);

IWRAM_CODE void Mode3DrawBg(u16* pImg);
IWRAM_CODE void Mode3DrawBgSmall(u16* pImg);
IWRAM_CODE void Mode3DrawFill(u16 col);
IWRAM_CODE void Mode3DrawFace(u16* pImg);
IWRAM_CODE void Mode3DrawCrop(u32 sx, u32 sy, u32 cx, u32 cy, u16* pImg);
IWRAM_CODE void Mode3DrawClip(u32 sx, u32 sy, u32 cx, u32 cy, u32 gx, u32 gy, u32 gs, u16* pImg);
IWRAM_CODE void Mode3DrawBlend(u32 sx, u32 sy, u32 cx, u32 cy, u16* pImg, u16* pMask);
IWRAM_CODE void Mode3DrawLine(u32 cnt, u16* pImg);
IWRAM_CODE void Mode3Copy(u32 sx, u32 sy, u32 cx, u32 cy);
IWRAM_CODE void Mode3Scroll(u32 cnt);
IWRAM_CODE void Mode3ScrollEd(void);

IWRAM_CODE void Mode3SetDrawBuf(void);
IWRAM_CODE void Mode3SetDrawFace(void);


#ifdef __cplusplus
}
#endif
#endif
