#include "link.h"
#include "libmy/bg.h"


//---------------------------------------------------------------------------
ST_LINK Link;


//---------------------------------------------------------------------------
EWRAM_CODE void LinkInit(void)
{
	_Memset(&Link, 0x00, sizeof(ST_LINK));

	Link.L = lua_open();

	luaopen_base(Link.L);
	luaopen_math(Link.L);
	lua_register(Link.L, "BgDrawStr", (void*)&LinkBgDrawStr);
	lua_register(Link.L, "BgDrawPoint", (void*)&LinkBgDrawPoint);
}
//---------------------------------------------------------------------------
EWRAM_CODE void LinkExec(void)
{
	int error = lua_pcall(Link.L, 0, LUA_MULTRET, 0);

	if(error != 0)
	{
		TRACEOUT("Lua Error: %s\n", lua_tostring(Link.L, -1));
		lua_pop(Link.L, 1);
	}

	lua_close(Link.L);
}
//---------------------------------------------------------------------------
EWRAM_CODE void  LinkSetFile(char* p)
{
	luaL_loadfile(Link.L, p);
}
//---------------------------------------------------------------------------
EWRAM_CODE void LinkBgDrawStr(lua_State* L)
{
	int x   = luaL_checkint(L, -3);
	int y   = luaL_checkint(L, -2);
	char* p = (char*)luaL_checkstring(L, -1);

	BgDrawStr(x, y, (char*)p);
}
//---------------------------------------------------------------------------
EWRAM_CODE void LinkBgDrawPoint(lua_State* L)
{
	int x = luaL_checkint(L, -3);
	int y = luaL_checkint(L, -2);
	int c = luaL_checkint(L, -1);

	BgDrawPoint(x, y, c);
}
