#include "manage.h"
#include "any.h"
#include "link.h"


//---------------------------------------------------------------------------
ST_MANAGE Manage;


//---------------------------------------------------------------------------
EWRAM_CODE void ManageInit(void)
{
	_Memset(&Manage, 0x00, sizeof(ST_MANAGE));

	Manage.act = MANAGE_ACT_INIT;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExec(void)
{
	switch(Manage.act)
	{
	case MANAGE_ACT_INIT:
		ManageExecInit();
		break;

	case MANAGE_ACT_RUN:
		ManageExecRun();
		break;

	case MANAGE_ACT_END:
		ManageExecEnd();
		break;

	default:
		SystemError("[Err] ManageExec Manage.act=%d\n", Manage.act);
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecInit(void)
{
	AnyInit();

	LinkInit();
	LinkSetFile("hello.lua");

	Manage.act = MANAGE_ACT_RUN;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecRun(void)
{
	LinkExec();

	Manage.act = MANAGE_ACT_END;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecEnd(void)
{
	// EMPTY
}
